*	TITLE	'User Programmable Character Driver'
*
* Copyright (c) 1985, 1989 LINDLEY SYSTEMS
*
* V3.5a 06/16/85 Uses same main logic as CP/M version
*
* Printer driver with User Programmable Characters
*
YES	EQU	0
NO	EQU	1
*
* START PRINTER SELECTION
MX	EQU	YES	; EPSON/STAR
OLDSTAR EQU	NO	; OLDER STAR PRINTERS (SG, SD, SR SERIES)
*			; REQUIRE NON-EPSON STANDARD CODES.  'MX' ABOVE
*			; MUST *ALSO* BE SET TO YES IF YOU PICK THIS.
ML82	EQU	NO	; MICROLINE 82/83
ML84	EQU	NO	; MICROLINE 84
ML92	EQU	NO	; MICROLINE 92/93
NC	EQU	NO	; NEC-8023, CITOH-8510
MPI	EQU	NO	; MPI 88G 99G 150
* END PRINTER SELECTION
*
* BEGIN INTERFACE SELECTION
U8250	EQU	YES	; Z-89 OR H8-4	SERIAL PORT
U8251	EQU	NO	; H8-5 SERIAL OR H8-2 PARALLEL PORT
U8255	EQU	NO	; TRU-DATA 8255 PARALLEL PORT
Z8255	EQU	NO	; H&H OR Z89-11 8255 PARALLEL PORT
DIRECT	EQU	NO	; DIRECT OUTPUT PORT
PERCOM	EQU	NO	; PERCOM Z CONTROLLER PARALLEL PORT
WIDGET	EQU	NO	; MICRO-WIDGET PARALLEL PORT
H89PIP	EQU	NO	;
* END INTERFACE SELECTION
*
ML	EQU	ML82+ML84+ML92-2
ML8292	EQU	ML82+ML92-1
ML8492	EQU	ML84+ML92-1
MXML84	EQU	MX+ML84-1
COUNT	EQU	MX+ML84+NC-2
MXCPM	EQU	1
ML82CPM EQU	1
ML84CPM EQU	1
ML92CPM EQU	1
NCCPM	EQU	1
MPICPM	EQU	1
MLCPM	EQU	1
	LON	IC
*
*
AIO.UNI EQU	041061A ACTIVE UNIT #
EC.DNS	EQU	010Q	DEVICE NOT SUITABLE
EC.DDA	EQU	027Q	DEVICE DRIVER ABORT
EC.UUN	EQU	033Q	UNKNOWN UNIT #
EC.UNA	EQU	036Q	UNIT NOT AVAILABLE
EC.ILO	EQU	037Q	ILLEGAL OPTION
EC.ILV	EQU	040Q	ILLEGAL OPTION VALUE
DVD.ENT EQU	002000A DEVICE DRIVER ENTRY
S.CAADR EQU	040333A CTRL-A,B,C,Z TEST ADDR
S.CONFL EQU	040332A CONSOLE FLAGS
CS.FLG	EQU	200Q	CTRL-S FLAG
$SNA	EQU	042201A SET - SKIP INPUT SPACES
$CNA	EQU	042207A SET - CONV TO NUMBER FROM ASCII
$TBLS	EQU	042215A SET - 2 BYTE TABLE SEARCH
$LBD	EQU	042223A SET - LOAD BAUD-RATE DIVISOR
$SOP	EQU	042226A SET - PROCESS OPTIONS
$PBF	EQU	042231A SET - PROCESS BIT FLAGS
$PBV	EQU	042234A SET - PROCESS BYTE VALUE
$TBRA	EQU	031076A BRANCH RELATIVE THROUGH TABLE
.DLY	EQU	000053A ROM DELAY ROUTINE
$TYPTX	EQU	031136A USE SUBROUTINE IN ROM
$MU86	EQU	031007A (A)*(D,E)->(H,L)
$SAVALL EQU	031054A SAVE ALL REGISTERS
$RSTALL EQU	031047A RESTORE ALL REGISTERS
.SCOUT	EQU	002Q	SCALL PRINT TO CONSOLE
*
* HDOS DRIVER CONTROL BLOCK
	CODE	PIC
	DB	307Q		; DEVICE DRIVER FLAG
	DB	4		; WRITE ONLY
	DB	00001111B	; MOUNTED UNIT MASK
	DB	4		; # OF UNITS
	DB	4,4,4,4,0,0,0,0 ; UNIT CAPABILITIES
	DB	307Q		; TAKES SET OPTIONS
DVD.HDR EQU	*
	DS	24	HDOS HEADER WORK AREA
*
* SET CODE ENTRY POINT
*
* SET COMMANDS ENTER HERE
* ENTRY (DE)	= LINE POINTER
*	(A)	= UNIT NUMBER
*
* EXIT	'C' CLEAR IF OK
*	'C' SET IF ERROR
*	(A) = ERROR CODE
*
* USES	ALL
*
SETNTR	EQU	*
	CPI	7
	JNC	SET1
	MOV	B,D
	MOV	C,E		(BC) = PARAMETER LIST ADDRESS
	XCHG
	SHLD	STADD		SAVE COMMAND LINE ADDRESS
	LXI	D,PRCTAB	(DE) = PROCESSOR TABLE ADDRESS
	LXI	H,OPTTAB	(HL) = OPTION TABLE ADDRESS
	CALL	$SOP		SET OPTIONS
	RC
	CALL	$SNA
	RZ			END OF SET COMMAND LINE
	MVI	A,EC.ILO	ILLEGAL OPTION SPECIFICATION
	STC
	RET
SET1	MVI	A,EC.UUN	UNKNOWN UNIT NUMBER
	STC
	RET
*
VAL1	LXI	D,SCCC
	JMP	V1
VAL2	LXI	D,SPORT
	JMP	V1
VAL3	LXI	D,SMASK
	JMP	V1
VAL4	LXI	D,SREADY
V1	CALL	SAVEIT
	CALL	$PBV	PROCESS BYTE VALUE
	JNC	HELP
	RET
 IF U8250
*
* BAUD - PROCESS BAUD RATE OPTION SPECIFICATION
*
* ENTRY (BC) = TEXT ADDRESS
*
* EXIT	(BC)   = TEXT ADDRESS UPDATED
*	'C' CLEAR IF OK
*	'C' SET IF ERROR
*	(A) = ERROR CODE
*
* USES	ALL
*
BAUD	EQU	*
	PUSH	H
	LXI	D,SBAUD SAVE AREA
	CALL	SAVEIT
	POP	H
	MVI	A,10	(A)  = DEFAULT RADIX
	CALL	$CNA	CONV TO NUMBER FROM ASCII
	JC	BAU1
	XCHG		(DE) = BAUD RATE VALUE
	CALL	$LBD
	JNZ	BAU1
	SHLD	LPBAUD SET BAUD RATE WORD
	JMP	HELP
BAU1	MVI	A,EC.ILV
	STC
	RET
 ENDIF
* 
* HELP - PROCESS HELP OPTION
*
* TYPE VALID OPTIONS ON USER CONSOLE
*
HELP	LXI	H,HELP1
	CALL	HLP
	LXI	H,HELP2
HLP	MOV	A,M
	CPI	'$'
	JZ	HEXIT
	SCALL	.SCOUT
	INX	H
	JMP	HLP
HEXIT	XRA	A
	RET
HELP1	EQU	*
	DB	'UPC Graphics Driver Version 3.6 (c) 1989 Lindley Systems'
	DB	10,10,9,'* '
 IF MX
 IF OLDSTAR
	DB	'Star Micronics'
 ELSE
	DB	'Epson/Compatible'
 ENDIF
 ENDIF
 IF ML
	DB	'Microline '
 ENDIF
 IF ML82
	DB	'82/83'
 ENDIF
 IF ML84
	DB	'84'
 ENDIF
 IF ML92
	DB	'92/93'
 ENDIF
 IF NC
	DB	'NEC-8023/CItoh 8510'
 ENDIF
 IF MPI
	DB	'MPI'
 ENDIF
	DB	10,9,'* '
 IF U8250
	DB	'8250 Serial'
 ENDIF
 IF U8251
	DB	'H8-5/H8-2'
 ENDIF
 IF U8255
	DB	'Tru-Data'
 ENDIF
 IF Z8255
	DB	'Z89-11/H&H Parallel'
 ENDIF
 IF DIRECT
	DB	'Direct'
 ENDIF
 IF PERCOM
	DB	'Percom ZFD'
 ENDIF
 IF WIDGET
	DB	'Micro-Widget'
 ENDIF
	DB	10,10,'Options:',10,10,'$'
*
* SAVE THE OPTION TEXT
*
SAVEIT	PUSH	H
	XCHG		HL -> SAVE AREA
	PUSH	B
	MOV	D,B
	MOV	E,C
	MVI	B,6
S1	LDAX	D	GET DATA BYTE
	INX	D
	MOV	M,A
	CPI	' '	SKIP LEADING BLANKS
	JZ	S1
	ANI	177Q
	ORA	A	LOOK FOR ENDING NULL
	JZ	S2
	MOV	M,A
	INX	H
	DCR	B
	JZ	SAVXIT
	JMP	S1
S2	MVI	M,32	ENDING SPACES
	INX	H
	DCR	B
	JNZ	S2
SAVXIT	POP	B
	POP	H
	RET
*	
* OPTION TABLE
*
OPTTAB	DW	OPTTABE 	END ADDRESS OF TABLE
	DB	6		NUMBER OF DATA BYTES
	DB	'CC','C'+200Q,VAL1I,8,0,255
	DW	LGCCC
*		STRING,PROCESS,RADIX,LOW,HIGH
	DB	'POR','T'+200Q,VAL2I,8,0,377Q
*		SET VALUE LOCATION
	DW	LPPORT
 IF U8250
	DB	'BAU','D'+200Q,BAUDI
	DB	0,0,0,0,0
 ENDIF
	DB	'MAS','K'+200Q,VAL3I,8,0,255
	DW	LPMASK
	DB	'READ','Y'+200Q,VAL4I,8,0,255
	DW	LPCOMP
	DB	'HEL','P'+200Q,HELPI
	DB	0,0,0,0,0
OPTTABE DB	0			END OF TABLE
*
* PROCESSOR TABLE
*
PRCTAB	DS	0
VAL1I	EQU	*-PRCTAB/2
	DW	VAL1
VAL2I	EQU	*-PRCTAB/2
	DW	VAL2
VAL3I	EQU	*-PRCTAB/2
	DW	VAL3
VAL4I	EQU	*-PRCTAB/2
	DW	VAL4
 IF U8250
BAUDI	EQU	*-PRCTAB/2
	DW	BAUD
 ENDIF
HELPI	EQU	*-PRCTAB/2
	DW	HELP
	CODE	-R
	DS	DVD.ENT-*
	ERRNZ	DVD.ENT-*
	CODE	+R
*
* ENTRY POINT MUST BE AT 512.
*	
* DRIVER ENTRY POINT.
*
* ENTRY (A) = PROCESS CODE
*	(BC) = BYTE COUNT
*	(DE) = MEMORY ADDRESS
* EXIT	'C' CLEAR = OK, SET = ERROR
*	(A) = ERROR CODE
* USES	ALL
*
	CALL	$TBRA		ENTER PROCESSOR
	DB	DDDNS-*		READ
	DB	WRITE-* 	WRITE
	DB	DDDNS-*		READR
	DB	DDDNS-*		OPENR
	DB	OPEN-*		OPENW
	DB	DDDNS-*		OPENU
	DB	CLOSE-* 	CLOSE
	DB	ABORT-* 	ABORT
	DB	DDDNS-*		MOUNT
	DB	LOAD-*		LOAD
	DB	DDNOP-*		READY
* HDOS 3 CALLS BELOW:
	DB	DDDNS-*		UPDATE SET PARAMATERS
	DB	DDNOP-*		UNLOAD DRIVER
	DB	DDDNS-*		INTERRUPT
	DB	DDDNS-*		DEVICE SPECIFIC
*
* DEVICE NOT SUITABLE FOR THIS OPERATION
*
DDDNS	MVI	A,EC.DNS	DEVICE NOT SUITABLE
	STC
	RET
*
* ISSUE DEVICE DRIVER ABORT TO REQUEST
*
ABORT	MVI	A,EC.DDA	DEVICE DRIVER ABORT
	STC
	RET
*
OPEN	LDA	AIO.UNI 	CURRENT UNIT NUMBER
	STA	LGCURD		SETS DOT DENSITY
	CALL	LPTINI
	CALL	LPTOS		IS PRINTER READY?
	MVI	A,EC.UNA
	STC
	RNZ			NOT READY; SHOW ERROR.
CLOSE	EQU	*
LOAD	EQU	*
DDNOP	XRA	A	SHOW NO ERROR
	RET
*	
* WRITE DATA TO THE DEVICE.
*
WRITE	XCHG
WRITE1	MOV	A,C	TEST BYTE COUNT
	ORA	B
	RZ
	PUSH	H
	PUSH	B
	MOV	C,M
	XRA	A
	CALL	GRCHAR
	POP	B
	POP	H
	JC	ABORT	LOOK FOR CTRL-C ABORT
	INX	H
	DCX	B
	JMP	WRITE1
*
	XTEXT	UPCUL1
	XTEXT	UPCIO
*
HELP2	DB	'CCC',9,9
SCCC	DB	'134   ',10
	DB	'PORT',9,9
 IF U8250
SPORT	DB	'340   ',10
	DB	'MASK',9,9
SMASK	DB	'040   ',10	DATA SET READY
	DB	'READY',9,9
SREADY	DB	'040   ',10	HIGH READY
	DB	'BAUD',9,9
SBAUD	DB	'9600  ',10
 ENDIF
 IF U8251
SPORT	DB	'340   ',10
	DB	'MASK',9,9
SMASK	DB	'001   ',10	TRANSMITTER READY
	DB	'READY',9,9
SREADY	DB	'001   ',10	HIGH FOR READY
 ENDIF
 IF U8255+Z8255-1
SPORT	DB	'320   ',10
	DB	'MASK',9,9
SMASK	DB	'020   ',10	PORT C, BIT 4
	DB	'READY',9,9
SREADY	DB	'000   ',10	LOW FOR READY HERE
 ENDIF
 IF DIRECT
SPORT	DB	'320   ',10
	DB	'MASK',9,9
SMASK	DB	'200   ',10	BUSY BIT
	DB	'READY',9,9
SREADY	DB	'000   ',10	HIGH BUSY, LOW READY
 ENDIF
 IF PERCOM
SPORT	DB	'340   ',10
	DB	'MASK',9,9
SMASK	DB	'040   ',10	BUSY BIT
	DB	'READY',9,9
SREADY	DB	'000   ',10	HIGH BUSY, LOW READY
 ENDIF
 IF WIDGET
SPORT	DB	'040   ',10
	DB	'MASK',9,9
SMASK	DB	'140   ',10	PORT C, BIT 4
	DB	'READY',9,9
SREADY	DB	'100   ',10	LOW READY
 ENDIF
 IF H89PIP
SPORT	DB	'324   ',10
	DB	'MASK',9,9
SMASK	DB	'004   ',10	BUSY BIT
	DB	'READY',9,9
SREADY	DB	'000   ',10	HIGH BUSY, LOW READY
 ENDIF
	DB	'HELP',10,'$'
*
STADD	DW	377377A START OF INPUT STRING
*
*
	DW	'RL'	RELOCATION ADDRESS
	END
